<?php
/**
*
* @copyright (c) 2011 Laf Innovative, Ltd.
* @license http://www.opensource.org/licenses/mit-license.php MIT License
* 
*/

require_once("./admin/database.php");
require_once("./admin/functions.php");
require('./admin/smarty/Smarty.class.php');
$smarty = new Smarty();
$smarty->template_dir =	'./admin/templates';
$smarty->compile_dir =	'./admin/smarty/templates_c';
$smarty->cache_dir =	'./admin/smarty/cache';
$smarty->config_dir =	'./admin/smarty/configs';

session_start();

$smarty->assign('dir_title', cfg("title"));
$smarty->assign('dir_url', cfg("url"));
$error = "";

if(isset($_REQUEST['url'])){ $url = $_REQUEST['url']; } else{ $url = ""; }
if(isset($_REQUEST['title'])){ $title = $_REQUEST['title']; } else{ $title = ""; }
if(isset($_REQUEST['description'])){ $description = $_REQUEST['description']; } else{ $description = ""; }
if(isset($_REQUEST['category'])){ $category = $_REQUEST['category']; } else{ $category = ""; }
if(isset($_REQUEST['email'])){ $email = $_REQUEST['email']; } else{ $email = ""; }
if(isset($_REQUEST['captcha'])){ $captcha = $_REQUEST['captcha']; } else{ $captcha = ""; }

if(isset($_REQUEST['add'])){
	if(cfg("captcha") == "1"){
		if(md5($captcha) != $_SESSION['image_value']){
			$error = "Visual validation string not valid. Please try again.<p>";
			}
		}

	if($url == ""){ $error = "You need to enter URL<p>"; }
	else{ $url = addslashes(htmlspecialchars($url)); }
	if($title == ""){ $error = "You need to enter title<p>"; }
	else{ $title = addslashes(htmlspecialchars($title)); }
	if($description == ""){ $error = "You need to enter description<p>"; }
	else{ $description = addslashes(htmlspecialchars($description)); }
	if($category == ""){ $error = "You need to select at least one category<p>"; }
	if($email == ""){ $error = "You need to enter email address<p>"; }

	if(!$error){
		if(cfg("addurl_gpr") != "0"){
			include('./admin/pagerank.php');
			$oPR = new GooglePR();
			$gpr = $oPR->GetPR($url);
			if($gpr < cfg("addurl_gpr")){ $error = "The URL you're suggesting has low Google PR of $gpr. At this time we can not accept such URLs. Please contact administration if you have any questions:<p>".cfg("email")."<p>"; }
			}
		}

	if(!$error){

		$Bresult = mysql_query("SELECT domain FROM banned");
		echo mysql_error();

		if(mysql_num_rows($Bresult)){

			while($Brow = mysql_fetch_array($Bresult)){

				preg_match('/' . preg_quote($Brow['domain'], '/') . '/', $url, $banned_domain);

				if(count($banned_domain) > 0){

					$error = "This domain was banned from our directory, please contact administration to resolve this issue: <p>".cfg("email")."<p>";

				}

				unset($banned_domain);

			}

		}

		$Bresult = mysql_query("SELECT keyword FROM bad_keywords");

		echo mysql_error();

		if(mysql_num_rows($Bresult)){

			while($Brow = mysql_fetch_array($Bresult)){

				preg_match('/' . preg_quote($Brow['keyword'], '/') . '/', $title, $banned_keyword);

				if(count($banned_keyword) > 0){

					$error = "Your title contains banned keywords, please contact administration to resolve this issue: <p>".cfg("email")."<p>";

				}

				unset($banned_keyword);

				preg_match('/' . preg_quote($Brow['keyword'], '/') . '/', $description, $banned_keyword);

				if(count($banned_keyword) > 0){

					$error = "Your description contains banned keywords, please contact administration to resolve this issue: <p>".cfg("email")."<p>";

				}

				unset($banned_keyword);

			}

		}

		if(!$error){

			$allowed_protocols = array('http://', 'https://');

			preg_match('/http(?:s)?:\/\//', $url, $protocol_match);

			if(!isset($protocol_match[0]) || !in_array($protocol_match[0], $allowed_protocols)){

				$error = "Please add \"http(s)://\" in front of your URL.";

			}

		}

		if(!$error){
			$Nresult = mysql_query("SELECT * FROM new_links");
			echo mysql_error();
			if(mysql_num_rows($Nresult)){ while ($Nrow = mysql_fetch_array($Nresult)) { if($url == $Nrow['url']){ $error = "This URL was already submitted. We will check it as soon as possible."; } } }

			if(!$error){
				$result = mysql_query("SELECT url FROM links");
				echo mysql_error();
				if(mysql_num_rows($result)){ while ($row = mysql_fetch_array($result)) { if($url == $row['url']){ $error = "This URL is already listed in our directory. Please contact administration if you have any questions: ".cfg("email"); } } }

				if(!$error){

					if(cfg("recip_required") == "1"){

						preg_match('/' . preg_quote(cfg("recip_regex"), '/') . '/', fetchURL($url), $recip_match);

						$res = count($recip_match) > 0 ? true : false;

						if($res !== true){

							$error = "There is no reciprocal link found back to " . cfg("title") . "!";

						}

					}

					if(!$error){
						mysql_query("INSERT INTO new_links (url, title, description, email, category) VALUES ('" . mysql_real_escape_string($url) . "', '" . mysql_real_escape_string($title) . "', '" . mysql_real_escape_string($description) . "', '" . mysql_real_escape_string($email) . "', '" . mysql_real_escape_string($category) . "')");
						$error = "Your URL was sucessfully submitted for editor review!<p>Feel free to submit another URL.<p>&nbsp;</p>";
						email_addurl_confirm($email, $url);
						}
					}
				}
			}
		}
	}

function list_catz($parent,$categories,$lev) {
	$space = "";
	for ($x = 0; $x < $lev; $x++) {
		$space .= "&nbsp;&nbsp; &middot; ";
		}
	$query = "SELECT id,title FROM categories WHERE parent='" . mysql_real_escape_string($parent) . "' ORDER BY title ASC";
	$result = mysql_query($query);
	echo mysql_error();
	if (mysql_num_rows($result) != 0){ 
		while ($row = mysql_fetch_array($result)) {
			//$result_num = mysql_query("SELECT id FROM links WHERE category_id = '" . mysql_real_escape_string($row['id']) . "'");
			echo mysql_error();
			//$links_num = mysql_num_rows($result_num);

                        $id = intval($row['id']); 
                        $title = $row['title']; 
                        //$categories .= "<option value=\"$id\">$space$title ($links_num)</option>\n"; 
                        $categories .= "<option value=\"$id\">$space$title</option>\n"; 
                        $categories .= list_catz($id,"",$lev+1); 
           		} 
		return $categories;
		}
	}
$smarty->assign('categories',list_catz(0,"",0));
$smarty->register_prefilter('a');
$smarty->assign('error',$error);
$smarty->assign('url',$url);
$smarty->assign('title',$title);
$smarty->assign('description',$description);
$smarty->assign('email',$email);


$smarty->display('addurl.html');

?>